type JSONKey = string | number | symbol;
type JSONWithPath<T> = {
    path: string;
    json: Record<JSONKey, T>;
};
type JSONArray<T extends object> = Array<JSONWithPath<T>>;
type KeyCounter = Record<JSONKey, string[]>;
type JsonWithMissingKeys = {
    path: string;
    missingKeys: string[];
};
declare class JsonDifference<T extends object> {
    private _fileRoutes;
    private _jsonArray;
    private _keyCounter;
    private _jSONWithMissingKeysArray;
    private _pathFinder;
    private _logger;
    constructor(paths: string[]);
    get fileRoutes(): string[];
    get keyCounter(): KeyCounter;
    get jsonArray(): JSONArray<T>;
    get jsonWithMissingKeysArray(): JsonWithMissingKeys[];
    private pushToJsonArray;
    private pushToJsonWithMissingKeysArray;
    copyJsonData(): this;
    encountKeys(): this;
    findMissingKeys(): this;
}

export { JsonDifference };
